#include <mach/gsensor.h>

#ifndef _GSENSOR_BOSCH_BMA150_H_
#define _GSENSOR_BOSCH_BMA150_H_


#define BMA150_REG_CHIP_ID					0x00
#define BMA150_REG_ML_VERSION				0x01
#define BMA150_REG_AL_VERSION				0x01
#define BMA150_REG_NEW_DATA_X			0x02
#define BMA150_REG_ACC_X_LSB				0x02
#define BMA150_REG_ACC_X_MSB				0x03
#define BMA150_REG_NEW_DATA_Y			0x04
#define BMA150_REG_ACC_Y_LSB				0x04
#define BMA150_REG_ACC_Y_MSB				0x05
#define BMA150_REG_NEW_DATA_Z			0x06
#define BMA150_REG_ACC_Z_LSB				0x06
#define BMA150_REG_ACC_Z_MSB				0x07
#define BMA150_REG_TEMP					0x08
#define BMA150_REG_STATUS_HG				0x09
#define BMA150_REG_STATUS_LG				0x09
#define BMA150_REG_HG_LATCHED			0x09
#define BMA150_REG_LG_LATCHED				0x09
#define BMA150_REG_ALERT_PHASE			0x09
#define BMA150_REG_ST_RESULT				0x09
#define BMA150_REG_SLEEP					0x0A
#define BMA150_REG_SOFT_RESET				0x0A
#define BMA150_REG_SELF_TEST_0			0x0A
#define BMA150_REG_SELF_TEST_1			0x0A
#define BMA150_REG_EE_W					0x0A
#define BMA150_REG_UPDATE_IMAGE			0x0A
#define BMA150_REG_RESET_INT				0x0A
#define BMA150_REG_ENABLE_LG				0x0B
#define BMA150_REG_ENABLE_HG				0x0B
#define BMA150_REG_COUNTER_LG				0x0B
#define BMA150_REG_COUNTER_HG			0x0B
#define BMA150_REG_ANY_MOTION			0x0B
#define BMA150_REG_ALERT					0x0B
#define BMA150_REG_LG_THRES				0x0C
#define BMA150_REG_LG_DUR					0x0D
#define BMA150_REG_HG_THRES				0x0E
#define BMA150_REG_HG_DUR					0x0F
#define BMA150_REG_ANY_MOTION_THRES		0x10
#define BMA150_REG_LG_HYST				0x11
#define BMA150_REG_HG_HYST				0x11
#define BMA150_REG_ANY_MOTION_DUR		0x11
#define BMA150_REG_BANDWIDTH				0x14
#define BMA150_REG_RANGE					0x14
#define BMA150_REG_WAKE_UP				0x15
#define BMA150_REG_WAKE_UP_PAUSE		0x15
#define BMA150_REG_SHADOW_DIS			0x15
#define BMA150_REG_LATCH_INT				0x15
#define BMA150_REG_NEW_DATA_INT			0x15
#define BMA150_REG_ENABLE_ADV_INT		0x15
#define BMA150_REG_SPI4					0x15
#define BMA150_REG_GAIN_X					0x16
#define BMA150_REG_OFFSET_X_LSB			0x16
#define BMA150_REG_GAIN_Y					0x17
#define BMA150_REG_OFFSET_Y_LSB			0x17
#define BMA150_REG_GAIN_Z					0x18
#define BMA150_REG_OFFSET_Z_LSB			0x18
#define BMA150_REG_GAIN_T					0x19
#define BMA150_REG_OFFSET_T_LSB			0x19
#define BMA150_REG_OFFSET_X_MSB			0x1A
#define BMA150_REG_OFFSET_Y_MSB			0x1B
#define BMA150_REG_OFFSET_Z_MSB			0x1C
#define BMA150_REG_OFFSET_T_MSB			0x1D
#define BMA150_REG_CTRL_0A				0x0A
#define BMA150_REG_CTRL_0B					0x0B
#define BMA150_REG_CTRL_14					0x14
#define BMA150_REG_CTRL_15					0x15


#define BMA150_REG_EEP_ENABLE_LG				0x2B
#define BMA150_REG_EEP_ENABLE_HG				0x2B
#define BMA150_REG_EEP_COUNTER_LG			0x2B
#define BMA150_REG_EEP_COUNTER_HG			0x2B
#define BMA150_REG_EEP_ANY_MOTION			0x2B
#define BMA150_REG_EEP_ALERT					0x2B
#define BMA150_REG_EEP_LG_THRES				0x2C
#define BMA150_REG_EEP_LG_DUR					0x2D
#define BMA150_REG_EEP_HG_THRES				0x2E
#define BMA150_REG_EEP_HG_DUR				0x2F
#define BMA150_REG_EEP_ANY_MOTION_THRES		0x30
#define BMA150_REG_EEP_LG_HYST				0x31
#define BMA150_REG_EEP_HG_HYST				0x31
#define BMA150_REG_EEP_ANY_MOTION_DUR		0x31
#define BMA150_REG_EEP_BANDWIDTH				0x34
#define BMA150_REG_EEP_RANGE					0x34
#define BMA150_REG_EEP_WAKE_UP				0x35
#define BMA150_REG_EEP_WAKE_UP_PAUSE		0x35
#define BMA150_REG_EEP_SHADOW_DIS			0x35
#define BMA150_REG_EEP_LATCH_INT				0x35
#define BMA150_REG_EEP_NEW_DATA_INT			0x35
#define BMA150_REG_EEP_ENABLE_ADV_INT		0x35
#define BMA150_REG_EEP_SPI4					0x35
#define BMA150_REG_EEP_GAIN_X					0x36
#define BMA150_REG_EEP_OFFSET_X_LSB			0x36
#define BMA150_REG_EEP_GAIN_Y					0x37
#define BMA150_REG_EEP_OFFSET_Y_LSB			0x37
#define BMA150_REG_EEP_GAIN_Z					0x38
#define BMA150_REG_EEP_OFFSET_Z_LSB			0x38
#define BMA150_REG_EEP_GAIN_T					0x39
#define BMA150_REG_EEP_OFFSET_T_LSB			0x39
#define BMA150_REG_EEP_OFFSET_X_MSB			0x3A
#define BMA150_REG_EEP_OFFSET_Y_MSB			0x3B
#define BMA150_REG_EEP_OFFSET_Z_MSB			0x3C
#define BMA150_REG_EEP_OFFSET_T_MSB			0x3D
#define BMA150_REG_EEP_CTRL_2B				0x2B
#define BMA150_REG_EEP_CTRL_34				0x34
#define BMA150_REG_EEP_CTRL_35				0x35


#define BMA150_CHIP_ID_MASK					0x07
#define BMA150_ML_VERSION_MASK				0x0F
#define BMA150_AL_VERSION_MASK				0xF0
#define BMA150_NEW_DATA_X_MASK				0x01
#define BMA150_NEW_DATA_Y_MASK				0x01
#define BMA150_NEW_DATA_Z_MASK				0x01
#define BMA150_ACC_X_LSB_MASK					0xC0
#define BMA150_ACC_Y_LSB_MASK					0xC0
#define BMA150_ACC_Z_LSB_MASK					0xC0
#define BMA150_STATUS_HG_MASK				0x01
#define BMA150_STATUS_LG_MASK				0x02
#define BMA150_HG_LATCHED_MASK				0x04
#define BMA150_LG_LATCHED_MASK				0x08
#define BMA150_ALERT_PHASE_MASK				0x08
#define BMA150_ST_RESULT_MASK					0x80
#define BMA150_SLEEP_MASK						0x01
#define BMA150_SOFT_RESET_MASK				0x02
#define BMA150_SELF_TEST_0_MASK				0x04
#define BMA150_SELF_TEST_1_MASK				0x08
#define BMA150_EE_W_MASK						0x10
#define BMA150_UPDATE_IMAGE_MASK				0x20
#define BMA150_RESET_INT_MASK					0x40
#define BMA150_ENABLE_LG_MASK					0x01
#define BMA150_ENABLE_HG_MASK				0x02
#define BMA150_COUNTER_LG_MASK				0x0C
#define BMA150_COUNTER_HG_MASK				0x30
#define BMA150_ANY_MOTION_MASK				0x40
#define BMA150_ALERT_MASK						0x80
#define BMA150_LG_HYST_MASK					0x07
#define BMA150_HG_HYST_MASK					0x38
#define BMA150_ANY_MOTION_DUR_MASK			0xC0
#define BMA150_BANDWIDTH_MASK				0x07
#define BMA150_RANGE_MASK						0x18
#define BMA150_WAKE_UP_MASK					0x01
#define BMA150_WAKE_UP_PAUSE_MASK			0x06
#define BMA150_SHADOW_DIS_MASK				0x08
#define BMA150_LATCH_INT_MASK					0x10
#define BMA150_NEW_DATA_INT_MASK			0x20
#define BMA150_ENABLE_ADV_INT_MASK			0x40
#define BMA150_SPI4_MASK						0x80
#define BMA150_GAIN_X_MASK					0x3F
#define BMA150_GAIN_Y_MASK					0x3F
#define BMA150_GAIN_Z_MASK					0x3F
#define BMA150_GAIN_T_MASK					0x3F
#define BMA150_OFFSET_X_LSB_MASK				0xC0
#define BMA150_OFFSET_Y_LSB_MASK				0xC0
#define BMA150_OFFSET_Z_LSB_MASK				0xC0
#define BMA150_OFFSET_T_LSB_MASK				0xC0


#define BMA150_ENABLE_ADV_INT_SHIFT		6
#define BMA150_WAKE_UP_PAUSE_SHIFT		1
#define BMA150_RANGE_SHIFT				3
#define BMA150_ANY_MOTION_DUR_SHIFT		6
#define BMA150_HG_HYST_SHIFT				3
#define BMA150_ALERT_SHIFT					6
#define BMA150_ANY_MOTION_SHIFT			6
#define BMA150_COUNTER_HG_SHIFT			4
#define BMA150_COUNTER_LG_SHIFT			2
#define BMA150_ENABLE_HG_SHIFT			1
#define BMA150_ACC_X_LSB_SHIFT			6
#define BMA150_ACC_Y_LSB_SHIFT			6
#define BMA150_ACC_Z_LSB_SHIFT			6
#define BMA150_ACC_T_LSB_SHIFT			6


#define BMA150_VALUE_ENABLE_ADV_INT(value)	(value << BMA150_ENABLE_ADV_INT_SHIFT)
#define BMA150_VALUE_WAKE_UP_PAUSE(value)	(value << BMA150_WAKE_UP_PAUSE_SHIFT)
#define BMA150_VALUE_RANGE(value)				(value << BMA150_RANGE_SHIFT)
#define BMA150_VALUE_BANDWIDTH(value)		(value)
#define BMA150_VALUE_ANY_MOTION_DUR(value)	(value << BMA150_ANY_MOTION_DUR_SHIFT)
#define BMA150_VALUE_HG_HYST(value)			(value << BMA150_HG_HYST_SHIFT)
#define BMA150_VALUE_LG_HYST(value)			(value)
#define BMA150_VALUE_ALERT(value)				(value << BMA150_ALERT_SHIFT)
#define BMA150_VALUE_ANY_MOTION(value)		(value << BMA150_ANY_MOTION_SHIFT)
#define BMA150_VALUE_COUNTER_LG(value)		(value << BMA150_COUNTER_LG_SHIFT)
#define BMA150_VALUE_COUNTER_HG(value)		(value << BMA150_COUNTER_HG_SHIFT)
#define BMA150_VALUE_ENABLE_HG(value)			(value << BMA150_ENABLE_HG_SHIFT)
#define BMA150_VALUE_ENABLE_LG(value)			(value)
#define BMA150_VALUE_SAMPLE(value)			(value << BMA150_ANY_MOTION_DUR_SHIFT)


#define BMA150_VALUE_WAKE_UP_PAUSE_20MS	BMA150_VALUE_WAKE_UP_PAUSE(BMA150_WAKE_UP_PAUSE_20MS)
#define BMA150_VALUE_WAKE_UP_PAUSE_80MS	BMA150_VALUE_WAKE_UP_PAUSE(BMA150_WAKE_UP_PAUSE_80MS)
#define BMA150_VALUE_WAKE_UP_PAUSE_320MS	BMA150_VALUE_WAKE_UP_PAUSE(BMA150_WAKE_UP_PAUSE_320MS)
#define BMA150_VALUE_WAKE_UP_PAUSE_2560MS	BMA150_VALUE_WAKE_UP_PAUSE(BMA150_WAKE_UP_PAUSE_2560MS)

#define BMA150_VALUE_RANGE_2G			BMA150_VALUE_RANGE(BMA150_RANGE_2G)
#define BMA150_VALUE_RANGE_4G			BMA150_VALUE_RANGE(BMA150_RANGE_4G)
#define BMA150_VALUE_RANGE_8G			BMA150_VALUE_RANGE(BMA150_RANGE_8G)

#define BMA150_VALUE_BANDWIDTH_25HZ		BMA150_VALUE_BANDWIDTH(BMA150_BANDWIDTH_25HZ)
#define BMA150_VALUE_BANDWIDTH_50HZ		BMA150_VALUE_BANDWIDTH(BMA150_BANDWIDTH_50HZ)
#define BMA150_VALUE_BANDWIDTH_100HZ	BMA150_VALUE_BANDWIDTH(BMA150_BANDWIDTH_100HZ)
#define BMA150_VALUE_BANDWIDTH_190HZ	BMA150_VALUE_BANDWIDTH(BMA150_BANDWIDTH_190HZ)
#define BMA150_VALUE_BANDWIDTH_375HZ	BMA150_VALUE_BANDWIDTH(BMA150_BANDWIDTH_375HZ)
#define BMA150_VALUE_BANDWIDTH_750HZ	BMA150_VALUE_BANDWIDTH(BMA150_BANDWIDTH_750HZ)
#define BMA150_VALUE_BANDWIDTH_1500HZ	BMA150_VALUE_BANDWIDTH(BMA150_BANDWIDTH_1500HZ)

#define BMA150_VALUE_COUNTER_LG_RESET	BMA150_VALUE_COUNTER_LG(BMA150_COUNTER_RESET
#define BMA150_VALUE_COUNTER_LG_1_LSB	BMA150_VALUE_COUNTER_LG(BMA150_COUNTER_1_LSB)
#define BMA150_VALUE_COUNTER_LG_2_LSB	BMA150_VALUE_COUNTER_LG(BMA150_COUNTER_2_LSB)
#define BMA150_VALUE_COUNTER_LG_3_LSB	BMA150_VALUE_COUNTER_LG(BMA150_COUNTER_3_LSB)

#define BMA150_VALUE_COUNTER_HG_RESET	BMA150_VALUE_COUNTER_HG(BMA150_COUNTER_RESET)
#define BMA150_VALUE_COUNTER_HG_1_LSB	BMA150_VALUE_COUNTER_HG(BMA150_COUNTER_1_LSB)
#define BMA150_VALUE_COUNTER_HG_2_LSB	BMA150_VALUE_COUNTER_HG(BMA150_COUNTER_2_LSB)
#define BMA150_VALUE_COUNTER_HG_3_LSB	BMA150_VALUE_COUNTER_HG(BMA150_COUNTER_3_LSB)

#define BMA150_VALUE_SAMPLE_1				BMA150_VALUE_SAMPLE(BMA150_SAMPLE_1)
#define BMA150_VALUE_SAMPLE_3				BMA150_VALUE_SAMPLE(BMA150_SAMPLE_3)
#define BMA150_VALUE_SAMPLE_5				BMA150_VALUE_SAMPLE(BMA150_SAMPLE_5)
#define BMA150_VALUE_SAMPLE_7				BMA150_VALUE_SAMPLE(BMA150_SAMPLE_7)


#define BMA150_BANDWIDTH_INIT				BMA150_VALUE_BANDWIDTH_25HZ
#define BMA150_RANGE_INIT					BMA150_VALUE_RANGE_2G
#define BMA150_ANY_MOTION_THRES_INIT		0x03

#endif

